// src/backend/concrete_statistics.cc - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#include "concrete_statistics.hh"
#include "sgpemv2/simulation.hh"
#include "sgpemv2/history.hh"
#include "sgpemv2/environment.hh"
#include "sgpemv2/schedulable.hh"
#include "sgpemv2/process.hh"
#include "sgpemv2/thread.hh"
#include "thread_statistics.hh"
#include "process_statistics.hh"

#include <iostream>

using namespace sgpem;
using namespace std;

ConcreteStatistics::ConcreteStatistics()
{}


vector<ProcessStatistics>
ConcreteStatistics::get_process_statistics(const int& instant) const
{
	//vector<ThreadStatistics*> thread_stats;
	vector<ProcessStatistics> rit;
	
	const History& 			hist 	= Simulation::get_instance().get_history();
	const Environment& 		env 	= hist.get_environment_at(instant);
	const vector<Process*> 	procs 	= env.get_processes();
	
	//first calculate all THREADS statistics
	for (uint i_p=0; i_p < procs.size(); i_p++)
	{
		/*const vector<Thread*> threads = procs[i_p]->get_threads();
		for (uint i_t = 0; i_t < threads.size(); i_t++)
		{
			ThreadStatistics* s = new ThreadStatistics(threads[i_t], instant);
			thread_stats.push_back(s);
			rit.push_back(s);
		}
		*/
		rit.push_back(ProcessStatistics(procs[i_p], instant));
	}	
	/*
	//then calculate PROCESSES statistics USING the previous ones
	for (uint i_p=0; i_p < procs.size(); i_p++)
	{
		SchedulableStatistics* s = new ProcessStatistics(procs[i_p], instant, &thread_stats);
		rit.push_back(s);		
	}	
	*/
	return rit;
}

